# std::ctype< char > Class Template Reference

Inheritance diagram for std::ctype< char >:

List of all members.

## Detailed Description

### template<>
class std::ctype< char >

This class defines classification and conversion functions for the char type. It gets used by char streams for many I/O operations. The char specialization provides a number of optimizations as well.

Definition at line 676 of file locale_facets.h.

## Public Types

- typedef const int * __to_type
- typedef char char_type
- typedef unsigned short mask

## Public Member Functions

- ctype (__c_locale __cloc, const mask *__table=0, bool __del=false, size_t __refs=0)
- ctype (const mask *__table=0, bool __del=false, size_t __refs=0)
- const char * is (const char *__lo, const char *__hi, mask *__vec) const
- bool is (mask __m, char __c) const
- const char_type * narrow (const char_type *__lo, const char_type *__hi, char __dfault, char *__to) const
- char narrow (char_type __c, char __dfault) const
- const char * scan_is (mask __m, const char *__lo, const char *__hi) const
- const char * scan_not (mask __m, const char *__lo, const char *__hi) const
- const char_type * tolower (char_type *__lo, const char_type *__hi) const
- char_type tolower (char_type __c) const
- const char_type * toupper (char_type *__lo, const char_type *__hi) const
- char_type toupper (char_type __c) const
- const char * widen (const char *__lo, const char *__hi, char_type *__to) const
- char_type widen (char __c) const

## Static Public Attributes

- static const mask alnum
- static const mask alpha
- static const mask cntrl
- static const mask digit
- static const mask graph
- static locale::id id
- static const mask lower
- static const mask print
- static const mask punct
- static const mask space
- static const size_t table_size
- static const mask upper
- static const mask xdigit

## Protected Member Functions

- virtual const char_type * do_narrow (const char_type *__lo, const char_type *__hi, char, char *__dest) const
- virtual char do_narrow (char_type __c, char) const
- virtual const char_type * do_tolower (char_type *__lo, const char_type *__hi) const
- virtual char_type do_tolower (char_type) const
- virtual const char_type * do_toupper (char_type *__lo, const char_type *__hi) const
- virtual char_type do_toupper (char_type) const
- virtual const char * do_widen (const char *__lo, const char *__hi, char_type *__dest) const
- virtual char_type do_widen (char __c) const
- const mask * table () const throw ()
- virtual ~ctype ()

## Static Protected Member Functions

- static __c_locale _S_clone_c_locale (__c_locale &__cloc)
- static void _S_create_c_locale (__c_locale &__cloc, const char *__s, __c_locale __old=0)
- static void _S_destroy_c_locale (__c_locale &__cloc)
- static __c_locale _S_get_c_locale ()
- static const char * _S_get_c_name ()
- static const mask * classic_table () throw ()

## Protected Attributes

- __c_locale _M_c_locale_ctype
- bool _M_del
- char _M_narrow [1+static_cast< unsigned char >(-1)]
- char _M_narrow_ok
- const mask * _M_table
- __to_type _M_tolower
- __to_type _M_toupper
- char _M_widen [1+static_cast< unsigned char >(-1)]
- char _M_widen_ok

## Friends

- class locale::_Impl

## Member Typedef Documentation

typedef char std::ctype< char >::char_type

Typedef for the template parameter char.

Definition at line 681 of file locale_facets.h.

## Constructor & Destructor Documentation

std::ctype< char >::ctype | ( | const mask * | __table = `0`,
|  | bool | __del = `false`,
|  | size_t | __refs = `0` |
| ) |  |  | `[explicit]`

Constructor performs initialization.

This is the constructor provided by the standard.

Parameters:

  | table | If non-zero, table is used as the per-char mask. Else classic_table() is used.
  | del | If true, passes ownership of table to this facet.
  | refs | Passed to the base facet class.

std::ctype< char >::ctype | ( | __c_locale | __cloc,
|  | const mask * | __table = `0`,
|  | bool | __del = `false`,
|  | size_t | __refs = `0` |
| ) |  |  | `[explicit]`

Constructor performs static initialization.

This constructor is used to construct the initial C locale facet.

Parameters:

  | cloc | Handle to C locale data.
  | table | If non-zero, table is used as the per-char mask.
  | del | If true, passes ownership of table to this facet.
  | refs | Passed to the base facet class.

virtual std::ctype< char >::~ctype | ( |  | ) | `[protected, virtual]`

Destructor.

This function deletes table() if del was true in the constructor.

## Member Function Documentation

static const mask* std::ctype< char >::classic_table | ( |  | ) | throw ()`[static, protected]`

Returns a pointer to the C locale mask table.

virtual const char_type* std::ctype< char >::do_narrow | ( | const char_type * | __lo,
|  | const char_type * | __hi,
|  | char | ,
|  | char * | __dest |
| ) |  |  | const`[inline, protected, virtual]`

Narrow char array to char array.

This virtual function converts each char in the range [lo,hi) to char using the simplest reasonable transformation and writes the results to the destination array. For any char in the input that cannot be converted, dfault is used instead. For an underived ctype<char> facet, the argument will be copied unchanged.

do_narrow() is a hook for a derived facet to change the behavior of narrowing. do_narrow() must always return the same result for the same input.

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters:

  | lo | Pointer to start of range.
  | hi | Pointer to end of range.
  | dfault | Char to use if conversion fails.
  | to | Pointer to the destination array.

Returns:
  hi.

Definition at line 1150 of file locale_facets.h.

virtual char std::ctype< char >::do_narrow | ( | char_type | __c,
|  | char |  |
| ) |  |  | const`[inline, protected, virtual]`

Narrow char.

This virtual function converts the char to char using the simplest reasonable transformation. If the conversion fails, dfault is returned instead. For an underived ctype<char> facet, c will be returned unchanged.

do_narrow() is a hook for a derived facet to change the behavior of narrowing. do_narrow() must always return the same result for the same input.

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters:

  | c | The char to convert.
  | dfault | Char to return if conversion fails.

Returns:
  The converted char.

Definition at line 1124 of file locale_facets.h.

virtual const char_type* std::ctype< char >::do_tolower | ( | char_type * | __lo,
|  | const char_type * | __hi |
| ) |  |  | const`[protected, virtual]`

Convert array to lowercase.

This virtual function converts each char in the range [lo,hi) to lowercase if possible. Other chars remain untouched.

do_tolower() is a hook for a derived facet to change the behavior of lowercasing. do_tolower() must always return the same result for the same input.

Parameters:

  | lo | Pointer to first char in range.
  | hi | Pointer to end of range.

Returns:
  hi.

virtual char_type std::ctype< char >::do_tolower | ( | char_type |  | ) | const`[protected, virtual]`

Convert to lowercase.

This virtual function converts the char argument to lowercase if possible. If not possible (for example, '2'), returns the argument.

do_tolower() is a hook for a derived facet to change the behavior of lowercasing. do_tolower() must always return the same result for the same input.

Parameters:

  | c | The char to convert.

Returns:
  The lowercase char if convertible, else c.

virtual const char_type* std::ctype< char >::do_toupper | ( | char_type * | __lo,
|  | const char_type * | __hi |
| ) |  |  | const`[protected, virtual]`

Convert array to uppercase.

This virtual function converts each char in the range [lo,hi) to uppercase if possible. Other chars remain untouched.

do_toupper() is a hook for a derived facet to change the behavior of uppercasing. do_toupper() must always return the same result for the same input.

Parameters:

  | lo | Pointer to start of range.
  | hi | Pointer to end of range.

Returns:
  hi.

virtual char_type std::ctype< char >::do_toupper | ( | char_type |  | ) | const`[protected, virtual]`

Convert to uppercase.

This virtual function converts the char argument to uppercase if possible. If not possible (for example, '2'), returns the argument.

do_toupper() is a hook for a derived facet to change the behavior of uppercasing. do_toupper() must always return the same result for the same input.

Parameters:

  | c | The char to convert.

Returns:
  The uppercase char if convertible, else c.

virtual const char* std::ctype< char >::do_widen | ( | const char * | __lo,
|  | const char * | __hi,
|  | char_type * | __dest |
| ) |  |  | const`[inline, protected, virtual]`

Widen char array.

This function converts each char in the range [lo,hi) to char using the simplest reasonable transformation. For an underived ctype<char> facet, the argument will be copied unchanged.

do_widen() is a hook for a derived facet to change the behavior of widening. do_widen() must always return the same result for the same input.

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters:

  | lo | Pointer to start of range.
  | hi | Pointer to end of range.
  | to | Pointer to the destination array.

Returns:
  hi.

Definition at line 1098 of file locale_facets.h.

virtual char_type std::ctype< char >::do_widen | ( | char | __c | ) | const`[inline, protected, virtual]`

Widen char.

This virtual function converts the char to char using the simplest reasonable transformation. For an underived ctype<char> facet, the argument will be returned unchanged.

do_widen() is a hook for a derived facet to change the behavior of widening. do_widen() must always return the same result for the same input.

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters:

  | c | The char to convert.

Returns:
  The converted character.

Definition at line 1075 of file locale_facets.h.

const char * std::ctype< char >::is | ( | const char * | __lo,
|  | const char * | __hi,
|  | mask * | __vec |
| ) |  |  | const`[inline]`

Return a mask array.

This function finds the mask for each char in the range [lo, hi) and successively writes it to vec. vec must have as many elements as the char array.

Parameters:

  | lo | Pointer to start of range.
  | hi | Pointer to end of range.
  | vec | Pointer to an array of mask storage.

Returns:
  hi.

Definition at line 51 of file ctype_inline.h.

bool std::ctype< char >::is | ( | mask | __m,
|  | char | __c |
| ) |  |  | const`[inline]`

Test char classification.

This function compares the mask table[c] to m.

Parameters:

  | c | The char to compare the mask of.
  | m | The mask to compare against.

Returns:
  True if m & table[c] is true, false otherwise.

Definition at line 46 of file ctype_inline.h.

const char_type* std::ctype< char >::narrow | ( | const char_type * | __lo,
|  | const char_type * | __hi,
|  | char | __dfault,
|  | char * | __to |
| ) |  |  | const`[inline]`

Narrow char array.

This function converts each char in the input to char using the simplest reasonable transformation and writes the results to the destination array. For any char in the input that cannot be converted, dfault is used instead. For an underived ctype<char> facet, the argument will be copied unchanged.

This function works as if it returns ctype<char>::do_narrow(lo, hi, dfault, to). do_narrow() must always return the same result for the same input.

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters:

  | lo | Pointer to start of range.
  | hi | Pointer to end of range.
  | dfault | Char to use if conversion fails.
  | to | Pointer to the destination array.

Returns:
  hi.

Definition at line 958 of file locale_facets.h.

char std::ctype< char >::narrow | ( | char_type | __c,
|  | char | __dfault |
| ) |  |  | const`[inline]`

Narrow char.

This function converts the char to char using the simplest reasonable transformation. If the conversion fails, dfault is returned instead. For an underived ctype<char> facet, c will be returned unchanged.

This function works as if it returns ctype<char>::do_narrow(c). do_narrow() must always return the same result for the same input.

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters:

  | c | The char to convert.
  | dfault | Char to return if conversion fails.

Returns:
  The converted character.

Definition at line 925 of file locale_facets.h.

const char * std::ctype< char >::scan_is | ( | mask | __m,
|  | const char * | __lo,
|  | const char * | __hi |
| ) |  |  | const`[inline]`

Find char matching a mask.

This function searches for and returns the first char in [lo,hi) for which is(m,char) is true.

Parameters:

  | m | The mask to compare against.
  | lo | Pointer to start of range.
  | hi | Pointer to end of range.

Returns:
  Pointer to a matching char if found, else hi.

Definition at line 60 of file ctype_inline.h.

const char * std::ctype< char >::scan_not | ( | mask | __m,
|  | const char * | __lo,
|  | const char * | __hi |
| ) |  |  | const`[inline]`

Find char not matching a mask.

This function searches for and returns a pointer to the first char in [lo,hi) for which is(m,char) is false.

Parameters:

  | m | The mask to compare against.
  | lo | Pointer to start of range.
  | hi | Pointer to end of range.

Returns:
  Pointer to a non-matching char if found, else hi.

Definition at line 70 of file ctype_inline.h.

const mask* std::ctype< char >::table | ( |  | ) | const throw ()`[inline, protected]`

the default from classic_table() if none was provided.

Definition at line 975 of file locale_facets.h.

const char_type* std::ctype< char >::tolower | ( | char_type * | __lo,
|  | const char_type * | __hi |
| ) |  |  | const`[inline]`

Convert array to lowercase.

This function converts each char in the range [lo,hi) to lowercase if possible. Other chars remain untouched.

tolower() acts as if it returns ctype<char>:: do_tolower(lo, hi). do_tolower() must always return the same result for the same input.

Parameters:

  | lo | Pointer to first char in range.
  | hi | Pointer to end of range.

Returns:
  hi.

Definition at line 847 of file locale_facets.h.

char_type std::ctype< char >::tolower | ( | char_type | __c | ) | const`[inline]`

Convert to lowercase.

This function converts the char argument to lowercase if possible. If not possible (for example, '2'), returns the argument.

tolower() acts as if it returns ctype<char>::do_tolower(c). do_tolower() must always return the same result for the same input.

Parameters:

  | c | The char to convert.

Returns:
  The lowercase char if convertible, else c.

Definition at line 830 of file locale_facets.h.

const char_type* std::ctype< char >::toupper | ( | char_type * | __lo,
|  | const char_type * | __hi |
| ) |  |  | const`[inline]`

Convert array to uppercase.

This function converts each char in the range [lo,hi) to uppercase if possible. Other chars remain untouched.

toupper() acts as if it returns ctype<char>:: do_toupper(lo, hi). do_toupper() must always return the same result for the same input.

Parameters:

  | lo | Pointer to first char in range.
  | hi | Pointer to end of range.

Returns:
  hi.

Definition at line 814 of file locale_facets.h.

char_type std::ctype< char >::toupper | ( | char_type | __c | ) | const`[inline]`

Convert to uppercase.

This function converts the char argument to uppercase if possible. If not possible (for example, '2'), returns the argument.

toupper() acts as if it returns ctype<char>::do_toupper(c). do_toupper() must always return the same result for the same input.

Parameters:

  | c | The char to convert.

Returns:
  The uppercase char if convertible, else c.

Definition at line 797 of file locale_facets.h.

const char* std::ctype< char >::widen | ( | const char * | __lo,
|  | const char * | __hi,
|  | char_type * | __to |
| ) |  |  | const`[inline]`

Widen char array.

This function converts each char in the input to char using the simplest reasonable transformation. For an underived ctype<char> facet, the argument will be copied unchanged.

This function works as if it returns ctype<char>::do_widen(c). do_widen() must always return the same result for the same input.

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters:

  | lo | Pointer to first char in range.
  | hi | Pointer to end of range.
  | to | Pointer to the destination array.

Returns:
  hi.

Definition at line 894 of file locale_facets.h.

char_type std::ctype< char >::widen | ( | char | __c | ) | const`[inline]`

Widen char.

This function converts the char to char_type using the simplest reasonable transformation. For an underived ctype<char> facet, the argument will be returned unchanged.

This function works as if it returns ctype<char>::do_widen(c). do_widen() must always return the same result for the same input.

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters:

  | c | The char to convert.

Returns:
  The converted character.

Definition at line 867 of file locale_facets.h.

## Member Data Documentation

locale::id std::ctype< char >::id`[static]`

The facet id for ctype<char>.

Definition at line 698 of file locale_facets.h.

const size_t std::ctype< char >::table_size`[static]`

The size of the mask table. It is SCHAR_MAX + 1.

Definition at line 700 of file locale_facets.h.

The documentation for this class was generated from the following files:

- locale_facets.h
- ctype_inline.h